PROMPT
PROMPT **** CREATION DU TYPE POUR LES CLIENTS *****
PROMPT
/
CREATE OR REPLACE TYPE F_BDT_TYPE_CUSTOMER AS OBJECT (
  CustomerNumber VARCHAR2(255),
  Income VARCHAR2(255),
  CustomerAdresse VARCHAR2(255),
  SolarSystem VARCHAR2(255),
  Quadran VARCHAR2(255),
  SpeciesCode VARCHAR2(255),
  Species VARCHAR2(255),
  MEMBER FUNCTION getCustomerNumber RETURN VARCHAR2,
  MEMBER FUNCTION getIncome RETURN VARCHAR2,
  MEMBER FUNCTION getCustomerAdresse RETURN VARCHAR2,
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2,
  MEMBER FUNCTION getQuadran RETURN VARCHAR2,
  MEMBER FUNCTION getSpeciesCode RETURN VARCHAR2,
  MEMBER FUNCTION getSpecies RETURN VARCHAR2
);
/
PROMPT
PROMPT **********  Implementation des methodes  ***************
PROMPT
/

CREATE OR REPLACE TYPE BODY F_BDT_TYPE_CUSTOMER
  IS
  MEMBER FUNCTION getCustomerNumber RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(3);
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(LSL)';
    tmp1 := regexp_substr(self.CustomerNumber, regex);
  
    if (length(tmp1) <> 3)
      then return 'ERREUR 1';
    end if;
    
    regex := '^(LSL\d*)';
    tmp := regexp_substr(self.CustomerNumber, regex);
    
    if (length(tmp) > 3)
      then RETURN tmp;
      else return 'ERREUR 2';
    end if;
  END ;
  MEMBER FUNCTION getIncome RETURN VARCHAR2
  IS
      tmp VARCHAR2(2);
      regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\d+)';
    tmp := regexp_substr(self.Income, regex);
    if (length(tmp) =0 )
      then return 'Erreur';
      ELSE IF (to_number(tmp)<6)
        then return 'LOW';
        ELSE IF(to_number(tmp)<11)
          THEN RETURN 'MEDIUM';
          ELSE IF(to_number(tmp)<16)
            THEN RETURN 'HIGH';
            ELSE RETURN 'VERY HIGH';
            END IF;
          END IF;
        END IF;
    end if;
  END ;
  MEMBER FUNCTION getCustomerAdresse RETURN VARCHAR2
  IS
    tmp VARCHAR2(30);
    regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\w+)';
    tmp := regexp_substr(self.CustomerAdresse, regex);
    if (length(tmp) = 0)
      then return 'VIDE';
      else return tmp;
    end if;
  END ;
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2
  IS
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\w+)';
    tmp := regexp_substr(self.SolarSystem, regex);
  
    if (length(tmp) =0 )
      then return 'VIDE';
      ELSE RETURN tmp;
    end if;
  END ;
  MEMBER FUNCTION getQuadran RETURN VARCHAR2
  IS
    tmp VARCHAR2(2);
    regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(Q\d)';
    tmp := regexp_substr(self.Quadran, regex);
  
    if (length(tmp) = 2)
      then return tmp;
      else return 'E1';
    end if;
  END ;
  MEMBER FUNCTION getSpeciesCode RETURN VARCHAR2
  IS
  BEGIN
    RETURN substr(self.SpeciesCode,0,8);
  END ;
  MEMBER FUNCTION getSpecies RETURN VARCHAR2
  IS
  BEGIN
    RETURN substr(self.Species,0,20);
  END ;
END ;
/
PROMPT
PROMPT ****  CREATION DE LA TABLE DES VENTES A PARTIR DU TYPE ****
PROMPT
CREATE TABLE F_BDT_CUSTOMER OF F_BDT_TYPE_CUSTOMER;

PROMPT
PROMPT ****  INSERTION DANS LA TABLE DEPUIS LES TABLES TEMPORAIRES ****
PROMPT
INSERT INTO F_BDT_CUSTOMER(CustomerNumber, Income, CustomerAdresse, SolarSystem, Quadran, SpeciesCode, Species)
  SELECT ct.CustomerNumber, ct.Income, ct.CustomerAdresse, ct.SolarSystem, ct.Quadran, ct.SpeciesCode, s.Species
  FROM F_BDT_CUSTOMER_TMP ct LEFT JOIN F_BDT_SPECIES s
  ON ct.SpeciesCode=s.SpeciesCode;