PROMPT
PROMPT **** CREATION DU TYPE POUR LES USINES *****
/
CREATE OR REPLACE TYPE F_BDT_TYPE_FACTORY AS OBJECT (
  Factory VARCHAR2(255),
  Creation VARCHAR2(255),
  YearOfCreation VARCHAR2(255),
  Capacity VARCHAR2(255),
  FactoryLocation VARCHAR2(255),
  SolarSystem VARCHAR2(255),
  Quadran VARCHAR2(255),
  MEMBER FUNCTION getFactory RETURN VARCHAR2,
  MEMBER FUNCTION getCreation RETURN DATE,
  MEMBER FUNCTION getYearOfCreation RETURN VARCHAR2,
  MEMBER FUNCTION getYearOfCreationSeg RETURN VARCHAR2,
  MEMBER FUNCTION getCapacity RETURN VARCHAR2,
  MEMBER FUNCTION getFactoryLocation RETURN VARCHAR2,
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2,
  MEMBER FUNCTION getQuadran RETURN VARCHAR2
);
/

CREATE OR REPLACE TYPE BODY F_BDT_TYPE_FACTORY
  IS
  MEMBER FUNCTION getFactory RETURN VARCHAR2
  IS
    tmp1 VARCHAR2(5);
    regex VARCHAR2(255);
  BEGIN
    regex := '^(\d+)';
    tmp1 := regexp_substr(self.Factory, regex);
  
    if (length(tmp1) = 0)
      then return 'ERROR';
      ELSE RETURN tmp1;
    end if;
  END ;
  
  MEMBER FUNCTION getCreation RETURN DATE
  IS
    tmp VARCHAR2(10);
    regex VARCHAR2(255);
  BEGIN 
        --Reformater un varchar2 en date: 
        regex := '^([0-9]{4}-[0-1][0-9]-[0-3][0-9])'; 
        tmp := regexp_substr(self.Creation, regex); 

        if (length(tmp) = 10) 
          then return to_date(tmp, 'yyyy-mm-dd');
          else return to_date('1999-01-01','yyyy-mm-dd'); 
        end if; 
  END ;
  MEMBER FUNCTION getYearOfCreation RETURN VARCHAR2
   IS
    tmp1 VARCHAR2(4);
    regex VARCHAR2(255);
  BEGIN
    regex := '^([0-9]{4})';
    tmp1 := regexp_substr(self.YearOfCreation, regex);
  
    if (length(tmp1) = 0)
      then return '0000';
      ELSE RETURN tmp1;
    end if;
  END ;
  MEMBER FUNCTION getYearOfCreationSeg RETURN VARCHAR2
   IS
    tmp1 VARCHAR2(4);
    regex VARCHAR2(255);
  BEGIN
    regex := '^([0-9]{4})';
    tmp1 := regexp_substr(self.YearOfCreation, regex);
  
    if (length(tmp1) = 0)
      then return '0000';
      ELSE IF ((tmp1>='2950') AND (tmp1<'2960'))
        THEN RETURN '2950';
        ELSE IF ((tmp1>='2960') AND (tmp1<'2970'))
          THEN RETURN '2960';
          ELSE IF ((tmp1>='2970') AND (tmp1<'2980'))
            THEN RETURN '2970';
            ELSE IF ((tmp1>='2980') AND (tmp1<'2990'))
              THEN RETURN '2980';
              ELSE IF ((tmp1>='2990') AND (tmp1<'3000'))
                THEN RETURN '2990';
                ELSE IF ((tmp1>='3000') AND (tmp1<'3010'))
                  THEN RETURN '3000';
                  ELSE IF ((tmp1>='3010') AND (tmp1<'3020'))
                    THEN RETURN '3010';
                    ELSE IF ((tmp1>='3020') AND (tmp1<'3030'))
                      THEN RETURN '3020';
                      ELSE IF ((tmp1>='3030') AND (tmp1<'3040'))
                        THEN RETURN '3030';
                        ELSE IF ((tmp1>='3040') AND (tmp1<'3050'))
                          THEN RETURN '3040';
                          ELSE IF ((tmp1>='3050') AND (tmp1<'3060'))
                            THEN RETURN '3050';
                            ELSE IF ((tmp1>='3060') AND (tmp1<'3070'))
                              THEN RETURN '3060';
                            END IF;
                          END IF;
                        END IF;
                      END IF;
                    END IF;
                  END IF;
                END IF;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    end if;
  END ;
  MEMBER FUNCTION getCapacity RETURN VARCHAR2
  IS
      tmp VARCHAR2(2);
      regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\d+)';
    tmp := regexp_substr(self.Capacity, regex);
    if (length(tmp) =0 )
      then return 'ERROR';
      ELSE IF (to_number(tmp)<4)
        then return 'LOW';
        ELSE IF(to_number(tmp)<7)
          THEN RETURN 'MEDIUM';
          ELSE IF(to_number(tmp)<11)
            THEN RETURN 'HIGH';
            ELSE RETURN 'VERY HIGH';
            END IF;
          END IF;
        END IF;
    end if;
  END ;
  MEMBER FUNCTION getFactoryLocation RETURN VARCHAR2
  IS
    tmp VARCHAR2(30);
    regex VARCHAR2(255);
  BEGIN
    --Reformater un varchar2 en date:
    regex := '^(\w+)';
    tmp := regexp_substr(self.FactoryLocation, regex);
    if (length(tmp) = 0)
      then return 'ERROR';
      else return tmp;
    end if;
  END ;
  MEMBER FUNCTION getSolarSystem RETURN VARCHAR2
  IS
  BEGIN
    if self.SolarSystem IS NOT NULL
      THEN RETURN self.SolarSystem;
      ELSE RETURN 'ERROR';
    end if;
  END ;
  MEMBER FUNCTION getQuadran RETURN VARCHAR2
  IS
  BEGIN
    if self.Quadran IS NOT NULL 
      then RETURN self.Quadran;
      else return 'ERROR';
    end if;
  END ;
END ;
/

PROMPT 
PROMPT ****  CREATION DE LA TABLE DES VENTES A PARTIR DU TYPE ****
CREATE TABLE F_BDT_FACTORY OF F_BDT_TYPE_FACTORY;

PROMPT 
PROMPT ****  INSERTION DANS LA TABLE DEPUIS LES TABLES TEMPORAIRES ****
INSERT INTO F_BDT_FACTORY(Factory, Creation, YearOfCreation, Capacity, FactoryLocation, SolarSystem, Quadran)
  SELECT f.Factory, f.Creation, f.YearOfCreation, f.Capacity, f.FactoryLocation, l.SolarSystem, l.Quadran
  FROM F_BDE_FACTORY f LEFT JOIN f_bdt_location l
  ON f.FactoryLocation = l.Planete;